#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu May 11 08:14:57 2017

@author: lessig
"""

import numpy as np
import matplotlib.pyplot as plt


N = 100
num_rand_tests = 100
errs = []
ks = []

for k in range( 100, 300, 10) :

    A = np.random.randn( N, k)
    # frame operator
    S = np.dot( A, A.transpose())
    # canonical dual frame
    Atilde = np.dot( np.linalg.inv( S).transpose(), A).transpose()
    
    err = 0.0
    for i in range( 1, num_rand_tests) :
        v = np.random.randn( N)
        vrec = np.dot( A, np.dot( Atilde, v))
        err += np.linalg.norm( v - vrec)
    
    errs.append( err / num_rand_tests)
    ks.append( k)
    
# plot errors
plt.semilogy( np.array(ks) / N, errs)
plt.title( 'error as a function of redundancy')
plt.xlabel( 'redundancy')
plt.ylabel( 'reconstruction error')
plt.savefig( 'rec_err_redundancy.pdf')
plt.show()
