#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue May  9 11:16:13 2017

@author: lessig
"""

import numpy as np
import matplotlib.pyplot as plt
from plotvectors import *

# synthesis operator
A = np.array( [[0.0, np.sqrt(3)/2, -np.sqrt(3)/2], [1.0, -1/2, -1/2]])
# plot frame
plt.figure()
plotVectors2D( A.transpose())
ax = plt.gca()
ax.set_xlim( [-1.2, 1.2])
ax.set_ylim( [-1.2, 1.2])
plt.savefig( 'mb.pdf')
plt.show()

# frame operator
S = np.dot( A, A.transpose())

# canonical dual frame
Atilde = np.dot( np.linalg.inv( S).transpose(), A).transpose()
plt.figure()
plotVectors2D( Atilde)
ax = plt.gca()
ax.set_xlim( [-1.2, 1.2])
ax.set_ylim( [-1.2, 1.2])
plt.savefig( 'mb_dual.pdf')
plt.show()

# Construct Parseval version of frame
 
AParseval = np.sqrt( 2 / 3) * A
SParseval = np.dot( AParseval, AParseval.transpose())
AParsevaltilde = np.dot( np.linalg.inv( SParseval).transpose(), AParseval).transpose()

diff = np.linalg.norm( AParsevaltilde.transpose() - AParseval)
print( 'diff Parseval = ', diff)
                               
